
local fps = 1/30
local fps_buffer = 0

function love.load()
  big = love.graphics.newImage((function() a = love.image.newImageData(640,480) a:mapPixel(function() return 255,255,255,255 end) return a end)())
  small = love.graphics.newImage((function() a = love.image.newImageData(32,32) a:mapPixel(function() return 255,255,255,255 end) return a end)())
  small:setWrap("repeat","repeat")
  small_sb = love.graphics.newSpriteBatch(small,20*15)
  small_q = love.graphics.newQuad(0,0,640,480,64,64)
  small_sbq = love.graphics.newSpriteBatch(small,1)
  small_sbq:add(small_q)
  mesh = love.graphics.newMesh({{0,0,0,0,255,255,255},{640,0,0,0,127,127,127},{0,480,0,0,127,127,127},{640,480,0,0,0,0,0}},small,"strip")
  for x=0,19 do
    for y=0,14 do
      small_sb:add(x*32,y*32)
    end
  end
  mode = 0
  d = 0
end

function love.update(dt)
  d = dt
end

function love.draw()
  if mode==0 then
    love.graphics.draw(big,0,0)
  elseif mode==1 then
    for x=0,19 do
      for y=0,14 do
        love.graphics.draw(small,x*32,y*32)
      end
    end
  elseif mode==2 then
    love.graphics.draw(small_sb,0,0)
  elseif mode==3 then
    love.graphics.rectangle("fill",0,0,640,480)
  elseif mode==4 then
    love.graphics.draw(mesh,0,0)
  elseif mode==5 then
    for x=0,19 do
      for y=0,14 do
        love.graphics.rectangle("fill",32*x,32*y,32,32)
      end
    end
  elseif mode==6 then
    love.graphics.draw(small_sbq)
  end

  love.graphics.setColor(0,0,0)
  love.graphics.print(d,0,0)
  love.graphics.print(mode,0,16)
  love.graphics.setColor(255,255,255)
  love.graphics.print(d,1,1)
  love.graphics.print(mode,1,17)
end

function love.mousepressed(x,y,button)
  
end

function love.keypressed(key)
  if key == "q" then
    mode = mode+1
    if mode > 6 then mode = 0 end
  elseif key == "escape" then
    love.event.quit()
  end
end
